// SaveRecDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample_MFC.h"
#include "SaveRecDlg.h"


// CSaveRecDlg dialog

IMPLEMENT_DYNAMIC(CSaveRecDlg, CDialog)
CSaveRecDlg::CSaveRecDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSaveRecDlg::IDD, pParent)
{
	m_pArtCam = NULL;
	m_pParam  = NULL;
	m_pDoc    = NULL;
}



CSaveRecDlg::~CSaveRecDlg()
{
}

void CSaveRecDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_REC, m_ComboRec);
}

BEGIN_MESSAGE_MAP(CSaveRecDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_REC, OnCbnSelchangeRec)
	ON_BN_CLICKED(IDB_REC, OnBnClickedRec)
END_MESSAGE_MAP()

// CSaveRecDlg message handlers


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Dialog format
//
//
BOOL CSaveRecDlg::OnInitDialog() {

	CDialog::OnInitDialog();

	m_ComboRec.InsertString(0, _T("Do not save slide images"));
	m_ComboRec.InsertString(1, _T("Save RAW data as original format"));
	m_ComboRec.InsertString(2, _T("Save pseudo color image as AVI format"));
	m_ComboRec.InsertString(3, _T("Save temperature data sa original format"));
	m_ComboRec.SetCurSel(0);



	/*****************************************************************************/
	// About slide images recording
	// During recording process, preview images are recording continuously 
	// since when Rec(FileName, RecMode) function is succeeded till Rec("", REC_NONE) function call again.
	// Restart recording when you start preview again even if you stop by Pause() function
	// In this time, saved AVI file's frame rate is rely on scanning frame number and recording time.
	// And it does not play on actual speed
	// This sample supposes that recording always operates on the dialog
	/*****************************************************************************/


	if(NULL != m_pArtCam && NULL != m_pParam)
	{
		// Always get recording condition from SDK
		m_pParam->NowRecording  = m_pArtCam->GetParam(PARAM_REC);
		m_pParam->RecMode		= m_pArtCam->GetParam(PARAM_RECMODE);
		if(m_pParam->NowRecording)
			GetDlgItem(IDB_REC)->SetWindowText(_T("Stop Rec"));
		else
			GetDlgItem(IDB_REC)->SetWindowText(_T("Start Rec"));
		
		m_ComboRec.SetCurSel((int)m_pParam->RecMode);
		OnCbnSelchangeRec();

		SetDlgItemInt(IDE_AVIMAXSIZE, m_pParam->AviMaxSize);
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Process when you choose recording format
//
//
void CSaveRecDlg::OnCbnSelchangeRec()
{
	LONG Sel = m_ComboRec.GetCurSel();
	
	// Set limitation of data size only when you save data as AVI format
	if(2 == Sel)	GetDlgItem(IDE_AVIMAXSIZE)->EnableWindow(TRUE);
	else			GetDlgItem(IDE_AVIMAXSIZE)->EnableWindow(FALSE);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Start / Stop recording
//
//
void CSaveRecDlg::OnBnClickedRec()
{
	if(NULL == m_pArtCam || NULL == m_pParam)
		return;

	LONG Sel = m_ComboRec.GetCurSel();  
	TCHAR szSaveFile[MAX_PATH]=_T(""); 

	// Get recording condition
	m_pParam->NowRecording = m_pArtCam->GetParam(PARAM_REC);

	// Process of stop recording
	if(REC_NONE == Sel || m_pParam->NowRecording){
		m_pArtCam->Rec(_T(""), REC_NONE);
		GetDlgItem(IDB_REC)->SetWindowText(_T("Start recording"));
		return;
	}

	// Set maximum size of saved AVI
	if (REC_IMAGE == Sel) {
		m_pParam->AviMaxSize = GetDlgItemInt(IDE_AVIMAXSIZE);
		m_pArtCam->SetParam(PARAM_AVIMAXSIZE, m_pParam->AviMaxSize);
	}

	// Frag if you get file name or not
	BOOL Flg = FALSE; 
	if (1 != m_pParam->NowRecording) {
		switch(Sel){
		case REC_DATA:	Flg = m_pDoc->GetFileNameDlg(m_hWnd, szSaveFile, _T("RAW file(*.raw)\0*.raw\0\0"), FALSE, _T("raw"), _T("_D_M"));	break;
		case REC_IMAGE:	Flg = m_pDoc->GetFileNameDlg(m_hWnd, szSaveFile, _T("AVI file(*.avi)\0*.avi\0\0"), FALSE, _T("avi"), _T("_C_M"));	break;
		case REC_T:		Flg = m_pDoc->GetFileNameDlg(m_hWnd, szSaveFile, _T("DAT file(*.dat)\0*.dat\0\0"), FALSE, _T("dat"), _T("_T_M"));	break;
		}
	}

	// Process start recording
	if(1 != m_pParam->NowRecording){
		if (Flg) {
			GetDlgItem(IDB_REC)->SetWindowText(_T("Finish recording"));
			m_pParam->RecMode = (RECMODE)Sel;
			m_pArtCam->Rec(szSaveFile, (RECMODE)Sel);
		}
	}

}
