// SaveFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample_MFC.h"
#include "SaveFileDlg.h"


// CSaveFileDlg dialog

IMPLEMENT_DYNAMIC(CSaveFileDlg, CDialog)
CSaveFileDlg::CSaveFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSaveFileDlg::IDD, pParent)
{
	m_pArtCam = NULL;
}

CSaveFileDlg::~CSaveFileDlg()
{
}

void CSaveFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_SAVE, m_ComboSave);
}


BEGIN_MESSAGE_MAP(CSaveFileDlg, CDialog)
	ON_BN_CLICKED(IDC_SAVE_FILE, OnBnClickedSaveFile)
END_MESSAGE_MAP()


// CSaveFileDlg message handlers


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Dialog format
//
//
BOOL CSaveFileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_ComboSave.InsertString( 0, _T("Save pseudo color image as bitmap"));
	m_ComboSave.InsertString( 1, _T("Save pseudo color image as RAW file"));
	m_ComboSave.InsertString( 2, _T("Save pseudo color image as JPEG (High resolution)"));
	m_ComboSave.InsertString( 3, _T("Save pseudo color image as JPEG (Normal)"));
	m_ComboSave.InsertString( 4, _T("Save pseudo color image as JPEG (Low resolution)"));
	m_ComboSave.InsertString( 5, _T("Save pseudo color image as PNG"));
	m_ComboSave.InsertString( 6, _T("Save pseudo color image as TIFF"));
	m_ComboSave.InsertString( 7, _T("Save RAW data as RAW file"));
	m_ComboSave.InsertString( 8, _T("Save RAW data as PNG"));
	m_ComboSave.InsertString( 9, _T("Save RAW data as TIFF"));
	m_ComboSave.InsertString(10, _T("Save temperature data as char array(integer)"));
	m_ComboSave.InsertString(11, _T("Save temperature data as BYTE array(integer)"));
	m_ComboSave.InsertString(12, _T("Save temperature data as LONG array(integer)"));
	m_ComboSave.InsertString(13, _T("Save temperature data as float array(Double)"));
	m_ComboSave.SetCurSel(0);

	return  TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Save specified file name
//
//
void CSaveFileDlg::OnBnClickedSaveFile()
{
	if(NULL == m_pArtCam)
		return;

	TCHAR	szSaveFile[MAX_PATH]	=	_T("");
	TCHAR	szText[64]				=	_T("Choose file");
	LONG	Sel						=	m_ComboSave.GetCurSel();
	BOOL	Flg						=	FALSE;
	HWND	hWnd					=	GetSafeHwnd();

	
	//
	// In this sample, actual saved file name is different from specified file name
	//
	switch(Sel){
		case FILETYPE_IMAGE_BITMAP:		Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("Bitmap(*.bmp)\0*.bmp\0\0"), FALSE, _T("bmp"), _T("_I"));		break;
		case FILETYPE_IMAGE_RAW:		Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("RAW file(*.raw)\0*.raw\0\0"),  FALSE, _T("raw"), _T("_I"));		break;
		case FILETYPE_IMAGE_JPEG_HIGH:	Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("JPEG file(*.jpg)\0*.jpg\0\0"), FALSE, _T("jpg"), _T("_I_H"));	break;
		case FILETYPE_IMAGE_JPEG_NOMAL:	Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("JPEG file(*.jpg)\0*.jpg\0\0"), FALSE, _T("jpg"), _T("_I_N"));	break;
		case FILETYPE_IMAGE_JPEG_LOW:	Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("JPEG file(*.jpg)\0*.jpg\0\0"), FALSE, _T("jpg"), _T("_I_L"));	break;
		case FILETYPE_IMAGE_PNG:		Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("PNG file(*.png)\0*.png\0\0"),  FALSE, _T("png"), _T("_I"));		break;
		case FILETYPE_IMAGE_TIFF:		Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("TIFF file(*.tif)\0*.tif\0\0"), FALSE, _T("tif"), _T("_I"));		break;
		case FILETYPE_DATA_RAW:			Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("RAW file(*.raw)\0*.raw\0\0"),  FALSE, _T("raw"), _T("_R"));		break;
		case FILETYPE_DATA_PNG:			Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("PNG file(*.png)\0*.png\0\0"),  FALSE, _T("png"), _T("_R"));		break;
		case FILETYPE_DATA_TIFF:		Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("TIFF file(*.tif)\0*.tif\0\0"), FALSE, _T("tif"), _T("_R"));		break;
		case FILETYPE_T_CHAR:			Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("DAT file(*.dat)\0*.dat\0\0"),  FALSE, _T("dat"), _T("_T_C"));	break;
		case FILETYPE_T_BYTE:			Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("DAT file(*.dat)\0*.dat\0\0"),  FALSE, _T("dat"), _T("_T_B"));	break;
		case FILETYPE_T_LONG:			Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("DAT file(*.dat)\0*.dat\0\0"),  FALSE, _T("dat"), _T("_T_L"));	break;	
		case FILETYPE_T_FLOAT:			Flg = m_pDoc->GetFileNameDlg(hWnd, szSaveFile, _T("DAT file(*.dat)\0*.dat\0\0"),  FALSE, _T("dat"), _T("_T_F"));	break;
	}

	// Save a still image
	if(Flg){
		m_pArtCam->Save(szSaveFile, (FILESAVETYPE)Sel);	
	}

	CDialog::OnOK();
}

